package com.zipcodewilmington.arrayutility;

import java.util.Arrays;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {

    T[] array;

    public ArrayUtility(T[] array) {
        this.array = array;
    }

    public T[] removeValue(T valueToRemove) {
        int index =0;
        for(int i = 0; i < array.length; i++) {
            if(array[i] != valueToRemove) {
                array[index] = array[i];
                index++;
            }
        }
        return Arrays.copyOf(array, index);
    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        Integer counter = 0;
        for(T element : array) {
            if(element == valueToEvaluate) {
                counter++;
            }
        }
        return counter;
    }

    public T[] mergeArrays(T[] arrayToMerge) {
        T[] mergedArray = Arrays.copyOf(array, array.length + arrayToMerge.length);

        for(int i = array.length; i < mergedArray.length; i++) {
            mergedArray[i] = arrayToMerge[i - array.length];
        }
        return mergedArray;
    }

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {
        T[] mergedArray = mergeArrays(arrayToMerge);
        Integer counter = 0;
        for(T element : mergedArray) {
            if(element == valueToEvaluate) {
                counter++;
            }
        }
        return counter;
    }

    public T getMostCommonFromMerge(T[] arrayToMerge) {
        T[] mergedArray = mergeArrays(arrayToMerge);
        T mostCommonElement = mergedArray[0];
        Integer countMostCommonDuplicates = 1;
        for (int i = 1; i < mergedArray.length; i++) {
            Integer countOfDuplicates = getNumberOfOccurrences(mergedArray[i]);
            if(countOfDuplicates > countMostCommonDuplicates) {
                mostCommonElement = mergedArray[i];
                countMostCommonDuplicates = countOfDuplicates;
            }
        }
        return mostCommonElement;
    }
}
